/*
 * Uebungen zur Verifikationsnumerik
 * Wissenschaftliches Rechnen / Softwaretechnologie
 * Bergische Universitaet Wuppertal
 *
 * Implementierung der Kreisscheibenarithmetik
 */

#include "complex.hpp"
#include "real.hpp"

using namespace std;
using namespace cxsc;

// Die Klasse cikreis
class cikreis {
	private:
		complex mid;
		real rad;

	public:
		// Konstruktoren
		cikreis() {}
		cikreis (complex m, real r) : mid(m), rad(r) {}
		cikreis (complex& m, real& r) : mid(m), rad(r) {}

		// Arithmetische Operatoren
		cikreis operator-();
		cikreis operator+(cikreis x);
		cikreis operator-(cikreis x);
		cikreis operator*(cikreis x);
		cikreis inv(cikreis x);
		cikreis operator/(cikreis x);

	// Ein- & Ausgabe
	friend istream& operator>>(istream& s, cikreis& a);
	friend ostream& operator<<(ostream& s, cikreis a);

	// Deklaration der Zugriffsfunktionen
	friend complex Mid(cikreis&);
	friend real MidRe(cikreis&);
	friend real MidIm(cikreis&);
	friend real Rad(cikreis&);
};

// Zugriffsfunktionen
inline complex Mid(cikreis& x) { return x.mid; }
inline real MidRe(cikreis& x)  { return Re(x.mid); }
inline real MidIm(cikreis& x)  { return Im(x.mid); }
inline real Rad(cikreis& x)    { return x.rad; }


// Hilfsfunktionen
complex sqr(complex a);
complex mittelpunkt(cinterval a);
